/*
 * Copyright (c) 2014 project TAMOP-4.2.2.C-11/1/KONV-2012-0013
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License version 2 as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

package lehurament.AggregateObservers;

import peersim.config.*;
import peersim.core.*;

/**
 */
public class SetVectForGAPPowerLaw extends peersim.vector.VectControl
{

// --------------------------------------------------------------------------
// Parameter names
// --------------------------------------------------------------------------

/**
 * @config
 */
private static final String PAR_RANK_EXPONENT="correlationFactor";
private static final String PAR_PERIODS = "periods";
private static final String PAR_CYCLES = "cycles";
private static final String PAR_FROM="from";
// --------------------------------------------------------------------------
// Fields
// --------------------------------------------------------------------------

private final double rankExponent;
private final int periods;
private final int cycles;
private final int from;
private int countconst=0;
private int count=0;
// --------------------------------------------------------------------------
// Initialization
// --------------------------------------------------------------------------

/**
 * Standard constructor that reads the configuration parameters.
 * Invoked by the simulation engine.
 * @param prefix the configuration prefix for this class
 */
public SetVectForGAPPowerLaw(String prefix)
{
	super(prefix);
	rankExponent = Configuration.getDouble(prefix + "." + PAR_RANK_EXPONENT);
    periods = Configuration.getInt(prefix + "." + PAR_PERIODS);
    cycles = Configuration.getInt(prefix + "." + PAR_CYCLES);
    from = Configuration.getInt(prefix + "." + PAR_FROM);
    countconst=5;
}

// --------------------------------------------------------------------------
// Methods
// --------------------------------------------------------------------------

/**
 * @return always false
 */
public boolean execute() {
//	if (CommonState.getTime()==from)
	 {
	count=countconst;
	double outdegree=0;
	for (int i = 0; i < Network.size(); i++) 
		{
			outdegree = 1/Math.pow(Network.size(),rankExponent)*Math.pow(count,rankExponent);
			setter.set(i,outdegree);
			count+=1;
			if (count>Network.size()) count=1;
		}
	if (countconst>=Network.size()) countconst=1;
	countconst+=1;
	}
	return false;
}

// --------------------------------------------------------------------------

}
